let g:loaded_python_provider=1      " Disable python 2 interface
let g:python_host_skip_check=1      " Skip python 2 host check
if filereadable('bin/python3')
    let g:python3_host_prog = '/bin/python3'
endif
if filereadable('~/.local/share/npm/bin/neovim-node-host')
    let g:node_host_prog = '~/.local/share/npm/bin/neovim-node-host'
endif
if executable("rg")
    set grepprg=rg\ --vimgrep
    set grepformat=%f:%l:%c:%m
endif
if empty(glob('~/.local/share/nvim/site/autoload/plug.vim'))
    silent !curl -fLo ~/.local/share/nvim/site/autoload/plug.vim --create-dirs
        \ https://raw.githubusercontent.com/junegunn/vim-plug/master/plug.vim
    autocmd VimEnter * PlugInstall --sync | call coc#util#install() | source $MYVIMRC
endif

if has('nvim')
  let $GIT_EDITOR = 'nvr -cc split --remote-wait'
endif

let mapleader="\<SPACE>"
let maplocalleader=','

set termguicolors
aug colores
    au!
    au ColorScheme * call dead#colores#Barra()
    au ColorScheme * call dead#colores#Maquillaje()
    au ColorScheme * call dead#colores#MyHighlights()
aug END
let g:srcery_transparent_background = 1
let g:srcery_italic = 1
let g:srcery_underline = 1
let g:srcery_undercurl = 1
colorscheme srcery

if filereadable(expand("~/.local/share/nvim/site/autoload/plug.vim"))
    call plug#begin(stdpath('data') . '/plugged')
    Plug 'dense-analysis/ale'
    Plug 'lervag/vimtex', {'for': 'latex'}
    Plug 'neoclide/coc.nvim', {'branch': 'release', 'for': ['javascript', 'html', 'css', 'json', 'typescript', 'jsx', 'tsx']}
    Plug 'fatih/vim-go', {'for': 'go', 'do': ':GoInstallBinaries'}
    Plug 'tpope/vim-fugitive'
    Plug 'airblade/vim-gitgutter'
    Plug 'junegunn/fzf.vim'
    Plug 'Shougo/defx.nvim', { 'do': ':UpdateRemotePlugins' }
    call plug#end()
endif
